use anyhow::Result;
use std::io::prelude::*;
use std::io::stdin;

fn main() -> Result<()> {
    let nums: Vec<i64> = stdin()
        .lock()
        .lines()
        .map(|line| {
            line.expect("unable to read input")
                .parse::<i64>()
                .expect("input is not a number")
        })
        .collect();
    'outer: for a in nums.iter() {
        for b in nums.iter() {
            if a + b == 2020 {
                println!("{} + {} = 2020", a, b);
                println!("product: {}", a * b);
                break 'outer;
            }
        }
    }
    'outer: for a in nums.iter() {
        for b in nums.iter() {
            for c in nums.iter() {
                if a + b + c == 2020 {
                    println!("{} + {} + {} = 2020", a, b, c);
                    println!("product: {}", a * b * c);
                    break 'outer;
                }
            }
        }
    }
    Ok(())
}
